<?php
require("localSidebar.php");
require("graph/navbar.inc.php");

function updateCallerGroup($name, $number, $users, $mode, $old_number="") {
    global $errorStatus;
    updateGroup($name, $old_number, $number, $users);
    if (!isXMLRPCError()) {
        $msg = $mode == "add" ? _T("Caller group added", "asterisk") : _T("Caller group updated", "asterisk");
        new NotifyWidgetSuccess($msg);
        redirectTo(urlStrRedirect("asterisk/default/callerGroups"));
    }
    else {
        $errorStatus = false;
    }
}

if (isset($_POST['badd']) || isset($_POST['bchange'])) {

    if (isset($_POST['badd'])) $mode = "add";
    else if (isset($_POST['bchange'])) $mode = "edit";

    $errors = "";

    if (!isset($_POST['group']) || empty($_POST['group'])) {
        $errors .= _T("A group name must be specified.", "asterisk") . '<br />';
        new NotifyWidgetFailure($errors);
        redirectTo(urlStrRedirect("asterisk/default/callerGroups"));
    }
    else {
        $group_name = $_POST['group'];
    }
    if (!isset($_POST['group_phone_number']) || empty($_POST['group_phone_number'])) {
        $errors .= _T("A phone number must be specified.", "asterisk") . '<br />';
    }
    else {
        $group_phone_number = $_POST['group_phone_number'];
    }

    if (!isset($_POST['group_users']) || empty($_POST['group_users'])) {
        $errors .= _T("At least one user must be specified.", "asterisk") . '<br />';
    }
    else {
        $group_users = $_POST['group_users'];
    }

    $old_group_phone_number = $_POST['old_group_phone_number'];

    if (empty($errors)) {
        updateCallerGroup($group_name, $group_phone_number,
                          $group_users, $mode,
                          $old_group_phone_number);
    }
    else {
        new NotifyWidgetFailure($errors);
    }
}

if (isset($_GET['group'])) {
    $mode = "edit";
    $submit = "bchange";
    $group_name = $_GET['group'];
    $group_name_widget = new HiddenTpl("group");
    $group_infos = getAsteriskGroup($group_name);
    $group_phone_number = $group_infos[1];
    $group_users = $group_infos[2];
    $title = _T("Edit caller group", "asterisk");
}
else {
    $mode = "add";
    $submit = "badd";
    $group_name = isset($_POST['group']) ? $_POST['group'] : "";
    $group_name_widget = new InputTpl("group");
    $group_phone_number = isset($_POST['group_phone_number']) ? $_POST['group_phone_number'] : "";
    $group_users = isset($_POST['group_users']) ? $_POST['group_users'] : array();
    $title = _T("Add caller group", "asterisk");
}

$p = new PageGenerator($title);
if ($mode == "edit") $sidemenu->forceActiveItem("callerGroups");
$p->setSideMenu($sidemenu);
$p->display();

$user_list = array();
list($userscount, $users) = getAsteriskUsers();

$f = new ValidatingForm();
$f->push(new Table());

$f->add(
    new TrFormElement(_T("Group name", "asterisk"), $group_name_widget),
    array("value" => $group_name)
);

$f->add(
    new TrFormElement(_T("Phone number", "asterisk"), new NumericInputTpl("group_phone_number")),
    array("value" => $group_phone_number)
);

$groupsTpl = new MembersTpl("group_users");
$groupsTpl->setTitle(_T("Group users", "asterisk"), _T("Asterisk users", "asterisk"));

$member = array();
foreach($group_users as $user) {
    if ($user)
        $member[$user] = $user;
}
$available = array();
foreach($users as $user) {
    if (!in_array($user['uid'], $member))
        $available[$user['uid']] = $user['uid'];
}

$f->add(
    new TrFormElement(_T("Group users", "asterisk"), $groupsTpl),
    array("member" => $member, "available" => $available)
);

$f->pop();
$f->addValidateButton($submit);
$f->display();

?>
